<?php
/**
* index.php
*
* This file acts as entry point and call appropriate controller.
*
* @author   Ravi Dhillon
*
*
*/

include('config.php');
include('inputsites.php');
include("lib/datasources/".DBMS."_manager.php");
$query_title;
$query_body;
$query_anchor;
$query_score = array();
$query_terms;

$db->connect();

//controllers available for simulator
$controllers_available = array("query","rank");

//deciding the controller to be run
if(isset($_POST['c']) && in_array($_POST['c'],$controllers_available)){
	$controller = $_POST['c'];
}
else{
	$controller = "query";
}

//function pointer to call the controller
$controller();

function query(){
	displayView("queryview");
}

function rank(){
	global $db;
	global $input_sites;
	include("./rank.php");
	rank_controller($db,$input_sites);
	displayView("rankview");
}


function displayView($viewname){
global $query_title;
global $query_body;
global $query_anchor;
global $query_score;
global $query_terms;
?>
<?php echo '<?xml version ="1.1" encoding="utf-8" ?>'; ?>
<!DOCTYPE html  PUBLIC "-//W3C//DTD XHTML 1.1//EN"
"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head>
<title>BM25F simulator</title>
<meta name="Authors" content="Ravi Dhillon" />
<meta name="description" content="This is a BM25F simulator developed for cs297" />
<meta name="keywords" content="BM25F,Rank, Page" />
<meta name="ROBOTS" content="NOINDEX, NOFOLLOW"/>
</head>
<body>
<div align="center">
<h1>BM25F simulator</h1>

<?php include("./{$viewname}.php"); ?>
</div>
</body>
</html>

<?php
}
?>
