<?php

include('config.php');
include('inputsites.php');
include("lib/datasources/".DBMS."_manager.php");
$no_of_pages;
$avg_title;
$avg_body;
$avg_anchor;

$db->connect();
create_tables($db);
generate_corpus($db,$input_sites);
echo "\nAverage Length[Title:".$avg_title." Body:".$avg_body." Anchor:".$avg_anchor."]\n";
generate_terms($db,$input_sites);

function create_tables($db)
{
    $result = $db->execute("SELECT * FROM CORPUS");
    
    if($result && $row = $db->fetch_array($result))
    {
       return;
    }
    
    $db->execute("DROP TABLE IF EXISTS CORPUS");
    $db->execute("CREATE TABLE CORPUS(URL TEXT, TITLE TEXT, TITLE_LENGTH INTEGER, BODY TEXT, BODY_LENGTH INTEGER, ANCHOR TEXT, ANCHOR_LENGTH INTEGER)");
    $db->execute("ALTER TABLE CORPUS ADD INDEX CORPUS_URL_INDEX ( URL ( 50 ) )  ");
    $db->execute("DROP TABLE IF EXISTS WORD_SCORE");
    $db->execute("CREATE TABLE WORD_SCORE(WORD TEXT, URL TEXT, TITLE_FREQ INTEGER, BODY_FREQ INTEGER, ANCHOR_FREQ INTEGER, SCORE FLOAT)");
     $db->execute("ALTER TABLE WORD_SCORE ADD INDEX SCORE_WORD_INDEX ( WORD ( 10 ) )  ");
    $db->execute("ALTER TABLE WORD_SCORE ADD INDEX CORPUS_URL_INDEX ( URL ( 50 ) )  ");

    echo "Tables created succesfully..\n\n";

}

function generate_terms($db,$input_sites)
{
    global $no_of_pages;
    global $avg_title;
    global $avg_body;
    global $avg_anchor;
    
    echo "\nGenerating terms...\n";
    foreach($input_sites as $input_site)
    {
        echo $input_site."\n";
        
        $sql = "SELECT * FROM CORPUS WHERE URL='".$input_site."'";
	
	$result = $db->execute($sql);
	
	if($result)
	{
	     $row = $db->fetch_array($result);
	     $title = trim(strtolower($row['TITLE']));
	     $title_length = $row['TITLE_LENGTH'];
	     $body = trim(strtolower($row['BODY']));
	     $body_length = $row['BODY_LENGTH'];
	     $anchor = trim(strtolower($row['ANCHOR']));	    
	     $anchor_length = $row['ANCHOR_LENGTH'];
	     $title_array = explode(" ",$title);
	     $body_array = explode(" ",$body);
	     $anchor_array = explode(" ",$anchor);	  
	     $title_count= array_count_values($title_array);
	     $body_count = array_count_values($body_array);
	     $anchor_count = array_count_values($anchor_array);	
	     
	     foreach($body_count as $term=>$bcount)
	     {
	          if($term=="")
	          {
	                continue;
	          }
	          if(isset($title_count[$term]))
   		  {
      			$tcount = $title_count[$term];  
   		  }
   		  else
   		  {
       			$tcount = 0;
       		  }
	     
	     	  if(isset($anchor_count[$term]))
   		  {
      			$acount = $anchor_count[$term];  
   		  }
   		  else
   		  {
       			$acount = 0;
       		  }
       		  $score = calculate_BM25F($db,$term,$bcount,$body_length,$tcount,$title_length,$acount,$anchor_length,$input_site);       		
       		  insert_into_word_score($db,$term,$input_site,$tcount,$bcount,$acount,$score);
       	     }
       	     foreach($title_count as $term=>$tcount)
       	     {
       	          if($term=="")
	          {
	                continue;
	          }
	          if(isset($body_count[$term]))
	          {
	          	continue;
	          }
	          else
	          {
       			$bcount = 0;
       		  }
	     
	     	  if(isset($anchor_count[$term]))
   		  {
      			$acount = $anchor_count[$term];  
   		  }
   		  else
   		  {
       			$acount = 0;
       		  }
       		  $score = calculate_BM25F($db,$term,$bcount,$body_length,$tcount,$title_length,$acount,$anchor_length,$input_site);       		 
       		  insert_into_word_score($db,$term,$input_site,$tcount,$bcount,$acount,$score);
              }
              foreach($anchor_count as $term=>$acount)
       	      {
       	          if($term=="")
	          {
	                continue;
	          }
	          if(isset($body_count[$term]))
	          {
	          	continue;
	          }
	          else
	          {
       			$bcount = 0;
       		  }
	     
	     	  if(isset($title_count[$term]))
   		  {
      			$tcount = $title_count[$term];  
   		  }
   		  else
   		  {
       			$tcount = 0;
       		  }
       		  $score = calculate_BM25F($db,$term,$bcount,$body_length,$tcount,$title_length,$acount,$anchor_length,$input_site);       		  
       		  insert_into_word_score($db,$term,$input_site,$tcount,$bcount,$acount,$score);
              }            
        }        
    }
}

function calculate_BM25F($db,$term,$bcount,$body_length,$tcount,$title_length,$acount,$anchor_length,$input_site)
{    
    global $no_of_pages;
    global $avg_title;
    global $avg_body;
    global $avg_anchor;
    $dft = 0;
        
    $sql = "SELECT COALESCE(INSTR(TITLE,'".$term." '),0)+ COALESCE(INSTR(BODY,'".$term." '),0)+ COALESCE(INSTR(ANCHOR,'".$term." '),0) AS OCCURS FROM CORPUS WHERE URL != '".$input_site."'";
    $result = $db->execute($sql);

    while($result && $row = $db->fetch_array($result))
    {
	   //echo $row['OCCURS']."\n";
	   if(intval($row['OCCURS'])!=0)
	   {
	      $dft += 1;
	   }
    }
    $dft += 1;
    
    $idft = log10(($no_of_pages-$dft+0.5)/($dft+0.5));
    $weight_title = ($tcount*38.4)/(1+0.95*($title_length/$avg_title)-0.95);
    $weight_body = ($bcount*1)/(1+0.7*($body_length/$avg_body)-0.7);
    $weight_anchor = ($acount*35)/(1+0.6*($anchor_length/$avg_anchor)-0.6);
    $weight = $weight_title + $weight_body + $weight_anchor;
    
    $score = ($weight*$idft)/(27.5 + $weight);
    return $score;
}
     

function generate_corpus($db,$input_sites)
{
    global $no_of_pages;
    global $avg_title;
    global $avg_body;
    global $avg_anchor;
    
    echo "Creating Corpus...\n\n";
    $anchor_text = array();
    $sum_title = 0;
    $sum_body = 0;
    $sum_anchor = 0;
    $no_of_pages = 0;
    echo "Populating title and body text..\n";
    foreach($input_sites as $input_site)
    {
        echo $input_site."\n";
        $no_of_pages += 1;
        $page = get_page($input_site);        
        $dom = html_dom($page);
        $document_text['title'] = html_title($dom);
        $document_length['title']= strlen($document_text['title']);
        $sum_title += $document_length['title'];       
        $document_text['body'] = html_body($dom);
        $document_length['body']= strlen($document_text['body']);
        $sum_body += $document_length['body'];
        insert_into_corpus($db,$input_site,$document_text['title'],$document_length['title'],$document_text['body'],$document_length['body']);
        $anchors = html_links($dom);
        foreach($anchors as $url=>$text)
        {
    	    if(in_array($url, $input_sites))
    	    {
    	         if(isset($anchor_text[$url]))
                 { 
                      $anchor_text[$url] .=" ".$text;
                 }
                 else
                 {
                      $anchor_text[$url] = $text;	  
                 }
    	        
    	    }
        }        
    }
    echo "\nUpdating anchors..\n";
    foreach($anchor_text as $url=>$text)
    {	
    	echo $url."\n";
    	$length = strlen($text);
    	$sum_anchor += $length; 
    	update_corpus($db,$url,$text,$length);
    }
    $avg_title = $sum_title / $no_of_pages;
    $avg_body = $sum_body / $no_of_pages;
    $avg_anchor = $sum_anchor / $no_of_pages;
    echo "\nTotal Length[Title:".$sum_title." Body:".$sum_body." Anchor:".$sum_anchor."]\n";  
}

function insert_into_word_score($db,$term,$url,$tcount,$bcount,$acount,$score)
{
    $sql = "INSERT INTO WORD_SCORE(WORD, URL, TITLE_FREQ, BODY_FREQ, ANCHOR_FREQ, SCORE) VALUES ('".
       $term."', '".$url.
       "', '".$tcount.
       "', '".$bcount.
       "', '".$acount.
       "', '".$score.
       "')";
   $db->execute($sql);
}

function insert_into_corpus($db,$url,$title_text,$title_length,$body_text,$body_length)
{
    $sql = "INSERT INTO CORPUS(URL, TITLE, TITLE_LENGTH, BODY, BODY_LENGTH) VALUES ('".
       $url."', '".$db->escape_string($title_text).
       "', '".$title_length.
       "', '".$db->escape_string($body_text).
       "', '".$body_length.
       "')";
   $db->execute($sql);
}

function update_corpus($db,$url,$anchor_text,$anchor_length)
{
    $sql = "UPDATE CORPUS SET ANCHOR = '".
       $db->escape_string($anchor_text)."', ANCHOR_LENGTH = '".$anchor_length.
       "' WHERE URL = '".$url."'";
   $db->execute($sql);
}
 
   
function html_dom($page)
{
   $dom = new DOMDocument();
   @$dom->loadHTML($page);
   
   return $dom;
}
function get_page($site)
{
    $agent = curl_init();
    curl_setopt($agent, CURLOPT_USERAGENT, USER_AGENT);
    curl_setopt($agent, CURLOPT_URL, $site);
    curl_setopt($agent, CURLOPT_FAILONERROR, true);
    curl_setopt($agent, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($agent, CURLOPT_AUTOREFERER, true);
    curl_setopt($agent, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($agent, CURLOPT_TIMEOUT, 5);

    return curl_exec($agent);
}

function html_title($dom)
{
   $sites = array();
    
   $xpath = new DOMXPath($dom);
   $titles = $xpath->evaluate("/html/head//title");
   
   $title = "";
   
   foreach($titles as $pre_title)
   {
      $title .= $pre_title->textContent;
   }
   $title = refine_text($title);
   return $title;
}

function html_body($dom)
{
    
   $xpath = new DOMXPath($dom);
   $bodys = $xpath->evaluate("/html//body");
   $body = "";
   foreach($bodys as $bodyss)
   {
   	$body .= $bodyss->textContent;
   }
   $body = refine_text($body);
   return $body;
}

function html_links($dom)
{
   $links = array();
    
   $xpath = new DOMXPath($dom);
   $hrefs = $xpath->evaluate("/html/body//a");
    
   foreach($hrefs as $href)
   {
      $url = $href->getAttribute('href');
      if(isset($links[$url]))
      { 
         $links[$url] .=refine_text($href->textContent);
      }
      else
      {
         $links[$url] = refine_text($href->textContent);	  
      }
   }
      
   return $links;  
}

function refine_text($text)
{
   $text1 = strip_tags(html_entity_decode($text));
   $text2 = ereg_replace("[^A-Za-z0-9' ]", " ", $text1 );
   $text3 = preg_replace("/[[:blank:]]+/"," ",$text2);
   return $text3." ";
}
     
?>
